import genfunc, pygame, math, random, copy
from pygame.locals import *

class primitive:
    def __init__(self,center=[450,320],radius=[10,20],color=[128,128,128],shape="rect",width=0):
        self.center=center
        self.radius=radius
        self.color=color
        self.shape=shape
        self.width=0
        
        self.ai=block()
        self.vel=[0,0]
        self.friction=1
        self.angle=0
        self.pain=20
        self.health=30
        self.tick=0
        self.hasshot=9
        self.score=10
        
    
    def draw(self,screen):
        
        if self.shape=="rect":
            self.points=genfunc.rect(
                self.center,
                self.radius)
            self.newpoints=genfunc.rot(self.points,self.angle,self.maincenter)
            self.newpoints=genfunc.translate(self.newpoints,[400,300])
            self.newpoints=[genfunc.norm(p) for p in self.newpoints]
            pygame.draw.polygon(
            screen,
            self.color,
            self.newpoints)
        if self.shape=="tri":
            self.points=genfunc.tri(
                self.center,
                self.radius)
            self.newpoints=genfunc.rot(self.points,self.angle,self.maincenter)
            self.newpoints=genfunc.translate(self.newpoints,[400,300])
            self.newpoints=[genfunc.norm(p) for p in self.newpoints]
            pygame.draw.polygon(
            screen,
            self.color,
            self.newpoints)
        if self.shape=="dash":
            self.points=[self.center,genfunc.translate([self.center],[self.vel[0],self.vel[1]])[0]]
            self.newpoints=genfunc.rot(self.points,self.angle,self.maincenter)
            self.newpoints=genfunc.translate(self.newpoints,[400,300])
            pygame.draw.line(
            screen,
            self.color,
            self.newpoints[0],self.newpoints[1])
        if self.shape=="circ":
            self.points=[self.center,]
            self.newpoints=genfunc.rot(self.points,self.angle,self.maincenter)
            self.newpoints=genfunc.translate(self.newpoints,[400,300])
            self.newpoints=[genfunc.norm(p) for p in self.newpoints]
            pygame.draw.circle(screen,self.color,self.newpoints[0],self.radius[0])
    
    def update(self,angle=0,maincenter=[400,300]):
        self.center[0]+=self.vel[0]
        self.center[1]+=self.vel[1]
        self.angle=math.radians(angle)
        self.maincenter=maincenter
        
        if hasattr(self.ai,"update"):
            self.ai.update(self)
        
    def collide(self,player):
            self.ai.collide(self,player)
        
    def home(self,player):
        self.ai.home(self,player)
            
    def shoot(self):
        pass
                
class person(primitive):
    def shoot(self,num=0):
        if num==0:
            for p in self.points[0:1]:
                pygame.event.post(pygame.event.Event(USEREVENT,{"inst":pshot,"args":(),"kwargs":{"center":p}}))
        elif num==1:
            for p in self.points[0:1]:
                pygame.event.post(pygame.event.Event(USEREVENT,{"inst":pbomb,"args":(),"kwargs":{"center":p}}))

class replicator(primitive):
    
    def __init__(self,center=[450,320],radius=[12,12],color=[55,75,160],vel=[0,0]):
        primitive.__init__(self,center,radius,color)
        self.vel=vel
        self.health=18
    
    def update(self,angle=0,maincenter=[400,300]):
        primitive.update(self,angle)
        if self.tick<51:self.tick+=1
        if (self.tick==40 or self.tick==43 or self.tick==46 or self.tick==49 ) and max([abs(x) for x in self.vel])>4:
            v= max([abs(x) for x in self.vel])-1.5
            vlist = [[v,0],[-v,0],[0,v],[0,-v]]
            pygame.event.post(pygame.event.Event(USEREVENT,{"inst":replicator,"args":(),"kwargs":{"vel":vlist[(self.tick-40)/3],"center":copy.deepcopy(self.center)}}))
            
            
class pshot(primitive):
    def __init__(self,center,color=[255,255,255]):
        primitive.__init__(self,center,[2,6],color,shape="dash")
        self.vel=[0,-12]
        self.pain=8
        self.health=1
        self.ai=ai()

class eshot(primitive):
    def __init__(self,center,color=[255,255,255]):
        primitive.__init__(self,center,[2,6],color,shape="dash")
        self.vel=[0,4]
        self.pain=8
        self.health=1
        self.ai=ai()

class pbomb(primitive):
    def __init__(self,center,color=[255,200,200]):
        primitive.__init__(self,center,[20,20],color,shape="rect")
        self.vel=[0,-12]
        self.pain=20
        self.health=200
        self.ai=ai()
        
class powerup(primitive):
    def __init__(self,center,color=[50,150,50]):
        primitive.__init__(self,center,[10,10],color,shape="circ")
        self.score=3
        self.vel=[0,1]
        self.pain=-5
        self.ai=power()

class shooter(primitive):
    def shoot(self):
        self.hasshot=max(0,self.hasshot-1)
        if not self.hasshot:
            self.hasshot=20
            for p in self.points[2:4]:
                pygame.event.post(pygame.event.Event(USEREVENT,{"inst":eshot,"args":(),"kwargs":{"center":p}}))
########################AI#############################

class ai:
    def collide(self,enemy,player):
        if genfunc.rectcollide(player.center,player.radius,enemy.center,enemy.radius):
            enemy.health-=player.pain
            player.health=min(100,player.health-enemy.pain)

            
    def home(self,enemy,player):
        pass

class block(ai):
    def collide(self,enemy,player):
        ai.collide(self,enemy,player)
        r=random.randint(0,25)
        if enemy.health<=0 and not hasattr(player,"ammo2"):
            pygame.event.post(pygame.event.Event(USEREVENT,{"score":enemy.score}))
            if 1<=r<=10:
                pygame.event.post(pygame.event.Event(USEREVENT,{"inst":powerup,"args":(enemy.center,),"kwargs":{}}))
            if r==0:
                pygame.event.post(pygame.event.Event(USEREVENT,{"inst":powerup,"args":(enemy.center,[255,200,200]),"kwargs":{}}))

class power(ai):
    def collide(self,enemy,player):
        if genfunc.rectcollide(player.center,player.radius,enemy.center,enemy.radius):
            
            if enemy.color==[50,150,50]:
                pygame.event.post(pygame.event.Event(USEREVENT,{"score":enemy.score}))
                enemy.health-=player.pain
                player.health-=enemy.pain
            elif enemy.color==[255,200,200]:
                pygame.event.post(pygame.event.Event(USEREVENT,{"score":enemy.score+2}))
                enemy.health-=player.pain
                player.ammo+=100
                player.ammo2+=1
        

class homing(block):
    def home(self,enemy,player):
        v=genfunc.cward(player.center,(0,0),enemy.center,(0,0))
        if genfunc.dot(enemy.vel,v)>0:
            enemy.center[0]+=v[0]*(enemy.vel[1]+1)
            enemy.center[1]+=v[1]*(enemy.vel[1]+1)
            
class sway(block):
    def __init__(self):
        self.vel=[4.5,2.5]
    def update(self,enemy):
        if enemy.center[0]<79:
            self.vel[0]*=-1
            enemy.center[0]+=self.vel[0]*2
        elif enemy.center[0]>700:
            self.vel[0]*=-1