import genfunc, units, random

class level:
    def __init__(self,prodlist):
        self.enemies=[]
        self.enemyshots=[]
        self.playershots=[]
        self.prodlist=prodlist
        
    def update(self,angle):
        for x in self.prodlist:
            p=x.update(angle)
            if p:
                self.enemies+=p
        for x in self.enemies + self.enemyshots+self.playershots:
            x.update(angle)
        self.enemies=[bob for bob in self.enemies if bob.center[1]<([400,300][1] + 390) and bob.health>0 and 0<bob.center[0]<800]
        self.playershots=[shot for shot in self.playershots if shot.center[1]>[400,300][1]-290 and shot.health>0]
        self.enemyshots=[shot for shot in self.enemyshots if shot.health>0]
    def draw(self,screen):
        for x in self.enemyshots + self.playershots + self.enemies:
            x.draw(screen)
    
    def collide(self,player):
        for enemy in self.enemies:
            enemy.collide(player)
            for shot in self.playershots:
                enemy.collide(shot)
                
        for shot in self.enemyshots:
            shot.collide(player)
            
    def home(self,player):
        for enemy in self.enemies:
            enemy.home(player)
    
    def shoot(self):
        for enemy in self.enemies:
            enemy.shoot()
            
class producer:
    def __init__(self, anglemin=0,anglemax=360, times=4,offset=0):
        self.anglemin=anglemin
        self.anglemax=anglemax
        self.times=times
        self.ticks=[int(330/times*x+offset)%330 for x in range(times)]
        
        self.tick=90
        
    def update(self,angle):
        self.tick+=1
        self.tick%=330
        if self.anglemin<=angle<=self.anglemax:
            if self.tick in self.ticks:
                return self.produce()
            
    def produce(self):
        pass

class blocker(producer):
    def produce(self):
        ret=[]
        for i in range(5):
            ret.append(units.primitive([random.randint(200,700),random.randint(-300,0)],[12,12]))
            ret[-1].vel[1]=random.randint(1,6)
            ret[-1].health+=10
        return ret
    
class wblocker(producer):
    def produce(self):
        ret=[]
        for i in range(3):
            ret.append(units.primitive([random.randint(200,700),random.randint(-300,0)],[12,12]))
            ret[-1].vel[1]=random.randint(1,6)
        return ret

class swayer(producer):
    def produce(self):
        if not hasattr(self,"sizes") or self.sizes>13:
            self.sizes=2
        tempai=units.sway()
        ret=[]
        self.sizes+=1
        if not self.sizes%2:tempai.vel[0]*=-1
        
        if self.sizes%2:
            for i in range(self.sizes):
                ret.append(units.primitive([(80+i*40),10],[20,12],color=[99-i*5,120+i*5,34+i*15]))
                ret[-1].ai=tempai
                ret[-1].vel=tempai.vel
                ret[-1].health-=12
        if not self.sizes%2:
            for i in range(self.sizes):
                ret.append(units.primitive([700-(80+i*40),10],[20,12],color=[99-i*5,120+i*5,30+i*15]))
                ret[-1].ai=tempai
                ret[-1].vel=tempai.vel
                ret[-1].health-=12
            ret.reverse()
        
        return ret
    
class homer(producer):
    def produce(self):
        ret=[]
        for i in range(6):
            ret.append(units.primitive([100+i*100,-20],[12,12],color=[150,90,120]))
            ret[-1].ai=units.homing()
            ret[-1].vel=[0,random.randint(1,3)]
        return ret
    
class spliter(producer):
    def produce(self):
        r=units.replicator([400,-100],[12,12],color=[75,90,180])
        r.vel=[random.randint(-1,1),8]
        r.health=400
        r.color=[200,40,40]
        return [r,]

class shooter(producer):
    def produce(self):
        ret=[]
        for i in range(3):
            ret.append(units.shooter([200+i*150+25*(self.tick%5),-20],[12,12],color=[120,50,120]))
            ret[-1].ai=units.block()
            ret[-1].vel=[0,2]
        return ret        